=== debian/changelog ===
srpc (0.9.6-1) unstable; urgency=low

  * Initial release. Closes: #1004346

 -- Lance Lin <lqi254@protonmail.com>  Thu, 10 Feb 2022 20:53:49 +0700
