=== debian/control ===
Source: srpc
Section: libs
Priority: optional
Maintainer: Lance Lin <lqi254@protonmail.com>
Build-Depends: cmake, debhelper (>= 13), debhelper-compat (= 13),
		libworkflow-dev, libssl-dev,
		libsnappy-dev (>= 1.1.6), libprotobuf-dev (>= 3.12.0),
		protobuf-compiler, liblz4-dev
Standards-Version: 4.6.0
Homepage: https://github.com/sogou/srpc
Vcs-Git: https://salsa.debian.org/debian/srpc.git
Vcs-Browser: https://salsa.debian.org/debian/srpc
Rules-Requires-Root: no

Package: libsrpc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Sogou RPC Library (SRPC)
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the runtime library.

Package: libsrpc-dev
Architecture: any
Depends: libsrpc (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Sogou RPC Library (SRPC)
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the development header files.
