## srpc 0.9.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,36 +1,53 @@
 cmake_minimum_required(VERSION 3.6)
 set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")
+set(CMAKE_SKIP_RPATH TRUE)
 
 project(srpc
-	VERSION 0.9.6
+	VERSION 0.9.7
 	LANGUAGES C CXX)
+	
+###Options
+
+if (WIN32)
+	option(SRPC_BUILD_STATIC_RUNTIME "Use static runtime" ON)
+endif ()
 
 #### CHECK
 
 include(CheckIncludeFile)
 include(CheckIncludeFileCXX)
 
+find_library(LZ4_LIBRARY NAMES lz4)
 check_include_file("lz4.h" LZ4_INSTALLED)
-if (NOT LZ4_INSTALLED)
+if (NOT LZ4_INSTALLED AND ${LZ4_LIBRARY} STREQUAL "LZ4_LIBRARY-NOTFOUND")
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
 		message( FATAL_ERROR "Lz4 is neither installed not in third_party!")
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
 		message("Lz4 third_party FOUND. Use for source code dependencies.")
-		set(LZ4_INSTALLED 0)
+		set(LZ4_INSTALLED 0 CACHE INTERNAL "check_lz4_installed")
+	else ()
+		find_path(LZ4_INCLUDE_DIR NAMES "lz4.h")
+		include_directories(${LZ4_INCLUDE_DIR})
+		set(LZ4_INSTALLED 1 CACHE INTERNAL "check_lz4_installed")
 	endif ()
 endif ()
 
+find_package(Snappy)
 check_include_file_cxx("snappy.h" SNAPPY_INSTALLED)
-if (NOT SNAPPY_INSTALLED)
+if (NOT SNAPPY_INSTALLED AND NOT ${Snappy_FOUND})
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
 		message( FATAL_ERROR "Snappy is neither installed not in third_party!")
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
 		message("Snappy third_party FOUND. Use for source code dependencies.")
-		set(SNAPPY_INSTALLED 0)
+		set(SNAPPY_INSTALLED 0 CACHE INTERNAL "check_snappy_installed")
+	else ()
+		find_path(Snappy_INCLUDE_DIR NAMES "snappy.h")
+		include_directories(${Snappy_INCLUDE_DIR})
+		set(SNAPPY_INSTALLED 1 CACHE INTERNAL "check_snappy_installed")
 	endif ()
 endif ()
 
@@ -91,6 +108,24 @@
 	makeLink(${PROJECT_SOURCE_DIR}/${header_file} ${INC_DIR}/${PROJECT_NAME}/${file_name} LINK_HEADERS)
 endforeach()
 
+if (WIN32)
+	if (SRPC_BUILD_STATIC_RUNTIME)
+		set(CompilerFlags
+				CMAKE_CXX_FLAGS
+				CMAKE_CXX_FLAGS_DEBUG
+				CMAKE_CXX_FLAGS_RELEASE
+				CMAKE_CXX_FLAGS_MINSIZEREL
+				CMAKE_C_FLAGS
+				CMAKE_C_FLAGS_DEBUG
+				CMAKE_C_FLAGS_RELEASE
+				CMAKE_C_FLAGS_MINSIZEREL
+				)
+		foreach(CompilerFlag ${CompilerFlags})
+			string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
+		endforeach ()
+	endif ()
+endif ()
+
 add_subdirectory(src)
 
 #### CONFIG
@@ -98,10 +133,14 @@
 include(CMakePackageConfigHelpers)
 set(CONFIG_INC_DIR ${INC_DIR})
 set(CONFIG_LIB_DIR ${LIB_DIR})
-if(NOT VCPKG_TOOLCHAIN)
-	set(CONFIG_BIN_DIR ${BIN_DIR})	
+
+if (VCPKG_TOOLCHAIN AND EXISTS "${CMAKE_INSTALL_PREFIX}/tools/srpc")
+	set(CONFIG_BIN_DIR ${CMAKE_INSTALL_PREFIX}/tools/srpc)
+	set(WITH_VCPKG_TOOLCHAIN 1 CACHE INTERNAL "build_with_vcpkg_toolchain")
+	message("Install with VCPKG toolchain. Dir ${CMAKE_INSTALL_PREFIX}/tools/srpc.")
 else()
-	set(CONFIG_BIN_DIR ${CMAKE_INSTALL_PREFIX}/tools/srpc)
+	set(CONFIG_BIN_DIR ${BIN_DIR})
+	set(WITH_VCPKG_TOOLCHAIN 0 CACHE INTERNAL "build_with_vcpkg_toolchain")
 endif()
 
 configure_package_config_file(
@@ -121,6 +160,12 @@
 	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR CONFIG_BIN_DIR
 )
 
+write_basic_package_version_file(
+	${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+	VERSION ${WORKFLOW_VERSION}
+	COMPATIBILITY AnyNewerVersion
+)
+
 install(
 	FILES ${CMAKE_CONFIG_INSTALL_FILE}
 	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
@@ -128,38 +173,11 @@
 	RENAME ${PROJECT_NAME}-config.cmake
 )
 
-#### PACK
-
-set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Sogou RPC")
-set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
-
-# set(CPACK_RPM_PRE_INSTALL_SCRIPT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/pre_script.sh)
-# set(CPACK_RPM_POST_INSTALL_SCRIPT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/post_script.sh)
-
-execute_process(
-	COMMAND git log -n1 --format=%ad --date=short
-	RESULT_VARIABLE GIT_LOG_RET
-	OUTPUT_VARIABLE GIT_YMD
-	OUTPUT_STRIP_TRAILING_WHITESPACE
+install(
+	FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
+	COMPONENT devel
 )
-
-if (NOT GIT_LOG_RET EQUAL 0)
-	set(GIT_YMD 0)
-endif()
-
-string(REPLACE "-" "" RELEASE_LABEL ${GIT_YMD})
-set(CPACK_RPM_PACKAGE_RELEASE ${RELEASE_LABEL})
-
-set(CPACK_RPM_COMPONENT_INSTALL ON)
-set(CPACK_COMPONENTS_ALL devel)
-set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
-set(CPACK_RPM_PACKAGE_RELEASE_DIST ON)
-
-set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/lib64/cmake)
-
-set(PB_PACKAGE_REQUIRED "protobuf-devel")
-
-set(CPACK_RPM_DEVEL_PACKAGE_REQUIRES "workflow-devel >= 0.9.9, ${PB_PACKAGE_REQUIRED}")
 
 install(
 	FILES ${INCLUDE_HEADERS}
@@ -172,9 +190,3 @@
 	DESTINATION "${CMAKE_INSTALL_DOCDIR}-${PROJECT_VERSION}"
 	COMPONENT devel
 )
-
-set(CPACK_RPM_SPEC_MORE_DEFINE "%define __spec_install_post /bin/true") # disable strip
-set(CPACK_GENERATOR "RPM")
-
-include(CPack)
-
