=== debian/changelog ===
srpc (0.9.7-1build1) lunar; urgency=medium

  * Rebuild against new libprotobuf32.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Jan 2023 17:47:54 +0100

srpc (0.9.7-1) unstable; urgency=low

  * Updated to new version (0.9.7)
  * Restructured package based on feedback. Closes: #1012004
  * Added support for dynamic library (new in 0.9.7) via libsprc0
  * d/control: added breaks/replaces for piuparts

 -- Lance Lin <lqi254@protonmail.com>  Thu, 16 Jun 2022 19:39:19 +0700
