=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libs
 Priority: optional
 Maintainer: Lance Lin <lqi254@protonmail.com>
-Build-Depends: cmake, debhelper (>= 13), debhelper-compat (= 13),
+Build-Depends: cmake, debhelper-compat (= 13),
 		libworkflow-dev, libssl-dev,
 		libsnappy-dev (>= 1.1.6), libprotobuf-dev (>= 3.12.0),
 		protobuf-compiler, liblz4-dev
@@ -12,10 +12,13 @@
 Vcs-Browser: https://salsa.debian.org/debian/srpc
 Rules-Requires-Root: no
 
-Package: libsrpc
+Package: libsrpc0
 Architecture: any
+Multi-Arch: same
+Breaks: libsrpc (<< 0.9.7-1)
+Replaces: libsrpc (<< 0.9.7-1)
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: Sogou RPC Library (SRPC)
+Description: Sogou RPC Library (SRPC) Generator
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of
  requests every day, mainly from search engines. It supports two common IDLs:
@@ -27,7 +30,10 @@
 
 Package: libsrpc-dev
 Architecture: any
-Depends: libsrpc (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
+Breaks: libsrpc (<< 0.9.7-1)
+Replaces: libsrpc (<< 0.9.7-1)
+Depends: libsrpc-bin (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Sogou RPC Library (SRPC)
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of
@@ -37,3 +43,19 @@
  tRPC.
  .
  This package contains the development header files.
+
+Package: libsrpc-bin
+Architecture: any
+Multi-Arch: foreign
+Breaks: libsrpc (<< 0.9.7-1)
+Replaces: libsrpc (<< 0.9.7-1)
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: Sogou RPC Library (SRPC) Generator
+ SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
+ many small and medium-sized companies.  It handles hundreds of millions of
+ requests every day, mainly from search engines. It supports two common IDLs:
+ protobuf and thrift, and implements several commonly used rpc protocols.
+ It is also an open source version of Tencent's enterprise-level RPC protocol,
+ tRPC.
+ .
+ This package contains the IDL file generator, srpc_generator
