## srpc 0.9.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_SKIP_RPATH TRUE)
 
 project(srpc
-	VERSION 0.9.7
+	VERSION 0.9.8
 	LANGUAGES C CXX)
 	
 ###Options
