=== src/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 if (WIN32)
 	find_package(Protobuf REQUIRED CONFIG)
 else ()
-	find_package(Protobuf 3.11.0 REQUIRED)
+	find_package(Protobuf 3.5.0 REQUIRED)
 endif ()
 
 if (WIN32)
@@ -145,7 +145,7 @@
 						  z ${SNAPPY_LIB} ${LZ4_LIB})
 		
 	set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
-	set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
+	set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME} VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR} )
 
 	add_dependencies(${STATIC_LIB_NAME} LINK_HEADERS)
 	add_dependencies(${SHARED_LIB_NAME} LINK_HEADERS)
