=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,12 @@
 if (WIN32)
 	find_package(Protobuf CONFIG REQUIRED)
 	find_library(LZ4_LIBRARY NAMES lz4)
+	if(LZ4_LIBRARY STREQUAL "LZ4_LIBRARY-NOTFOUND")
+		find_package(lz4)
+		if(lz4_FOUND)
+			set(LZ4_LIBRARY ${lz4_LIBRARIES})
+	    endif()
+	endif()
 	find_package(Snappy CONFIG REQUIRED)
 else ()
 	find_package(Protobuf REQUIRED)
@@ -88,7 +94,7 @@
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_pb.proto  ${PROJECT_SOURCE_DIR}
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_thrift.thrift ${PROJECT_SOURCE_DIR}
 	COMMAND ${SRPC_GEN_PROGRAM} protobuf ${PROJECT_SOURCE_DIR}/helloworld.proto ${PROJECT_SOURCE_DIR}
-	COMMENT "sprc generator..."
+	COMMENT "srpc generator..."
 )
