=== debian/changelog ===
srpc (0.9.8-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * libsrpc-dev: Add missing Depends (Closes: #1035456)

 -- Bastian Germann <bage@debian.org>  Fri, 12 May 2023 19:39:47 +0200

srpc (0.9.8-1) unstable; urgency=low

  * Updated to new version (0.9.8)
  * d/copyright:
      - update years to 2023
      - edit superfluous file pattern
  * d/control: bump standards version to 4.6.2
  * d/patches:
      - removed obsolete add-soname.patch
      - add description for remove-tutorial-check-targets.patch

 -- Lance Lin <lq27267@gmail.com>  Wed, 01 Mar 2023 21:41:10 +0700
