=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: srpc
 Section: libs
 Priority: optional
-Maintainer: Lance Lin <lqi254@protonmail.com>
+Maintainer: Lance Lin <lq27267@gmail.com>
 Build-Depends: cmake, debhelper-compat (= 13),
 		libworkflow-dev, libssl-dev,
 		libsnappy-dev (>= 1.1.6), libprotobuf-dev (>= 3.12.0),
 		protobuf-compiler, liblz4-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/sogou/srpc
 Vcs-Git: https://salsa.debian.org/debian/srpc.git
 Vcs-Browser: https://salsa.debian.org/debian/srpc
@@ -18,7 +18,7 @@
 Breaks: libsrpc (<< 0.9.7-1)
 Replaces: libsrpc (<< 0.9.7-1)
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: Sogou RPC Library (SRPC) Generator
+Description: Sogou RPC (SRPC) Runtime Library
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of
  requests every day, mainly from search engines. It supports two common IDLs:
@@ -33,7 +33,10 @@
 Multi-Arch: same
 Breaks: libsrpc (<< 0.9.7-1)
 Replaces: libsrpc (<< 0.9.7-1)
-Depends: libsrpc-bin (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends:
+ libsrpc0 (= ${binary:Version}),
+ libsrpc-bin (= ${binary:Version}),
+ ${misc:Depends}, ${shlibs:Depends}
 Description: Sogou RPC Library (SRPC)
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of
